Index: kernel/arch/arm32/include/mm/km.h
===================================================================
--- kernel/arch/arm32/include/mm/km.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ kernel/arch/arm32/include/mm/km.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,57 @@
+/*
+ * Copyright (c) 2011 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup arm32mm
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_arm32_KM_H_
+#define KERN_arm32_KM_H_
+
+#include <typedefs.h>
+
+#define KM_ARM32_IDENTITY_START		UINT32_C(0x80000000)
+#define KM_ARM32_IDENTITY_SIZE		UINT32_C(0x70000000)
+
+#define KM_ARM32_NON_IDENTITY_START	UINT32_C(0xf0000000)
+/*
+ * The last virtual megabyte contains the high exception vectors (0xFFFF0000).
+ * Do not include this range into kernel non-identity.
+ */
+#define KM_ARM32_NON_IDENTITY_SIZE	UINT32_C(0x0ff00000)
+
+extern void km_identity_arch_init(void);
+extern void km_non_identity_arch_init(void);
+extern bool km_is_non_identity_arch(uintptr_t);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/arm32/include/mm/page.h
===================================================================
--- kernel/arch/arm32/include/mm/page.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/arm32/include/mm/page.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -54,9 +54,9 @@
 
 /* Number of entries in each level. */
-#define PTL0_ENTRIES_ARCH 	(2 << 12)	/* 4096 */
+#define PTL0_ENTRIES_ARCH 	(1 << 12)	/* 4096 */
 #define PTL1_ENTRIES_ARCH 	0
 #define PTL2_ENTRIES_ARCH 	0
 /* coarse page tables used (256 * 4 = 1KB per page) */
-#define PTL3_ENTRIES_ARCH 	(2 << 8)	/* 256 */
+#define PTL3_ENTRIES_ARCH 	(1 << 8)	/* 256 */
 
 /* Page table sizes for each level. */
Index: kernel/arch/arm32/src/arm32.c
===================================================================
--- kernel/arch/arm32/src/arm32.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/arm32/src/arm32.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -38,5 +38,4 @@
 #include <genarch/fb/fb.h>
 #include <abi/fb/visuals.h>
-#include <sysinfo/sysinfo.h>
 #include <console/console.h>
 #include <ddi/irq.h>
@@ -58,5 +57,5 @@
 	size_t i;
 	for (i = 0; i < init.cnt; i++) {
-		init.tasks[i].addr = (uintptr_t) bootinfo->tasks[i].addr;
+		init.tasks[i].paddr = KA2PA(bootinfo->tasks[i].addr);
 		init.tasks[i].size = bootinfo->tasks[i].size;
 		str_cpy(init.tasks[i].name, CONFIG_TASK_NAME_BUFLEN,
Index: kernel/arch/arm32/src/mach/gta02/gta02.c
===================================================================
--- kernel/arch/arm32/src/mach/gta02/gta02.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/arm32/src/mach/gta02/gta02.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -38,4 +38,5 @@
 #include <arch/mm/page.h>
 #include <mm/page.h>
+#include <mm/km.h>
 #include <genarch/fb/fb.h>
 #include <abi/fb/visuals.h>
@@ -65,5 +66,5 @@
 static void gta02_timer_irq_start(void);
 static void gta02_cpu_halt(void);
-static void gta02_get_memory_extents(uintptr_t *start, uintptr_t *size);
+static void gta02_get_memory_extents(uintptr_t *start, size_t *size);
 static void gta02_irq_exception(unsigned int exc_no, istate_t *istate);
 static void gta02_frame_init(void);
@@ -101,6 +102,8 @@
 	s3c24xx_irqc_regs_t *irqc_regs;
 
-	gta02_timer = (void *) hw_map(S3C24XX_TIMER_ADDRESS, PAGE_SIZE);
-	irqc_regs = (void *) hw_map(S3C24XX_IRQC_ADDRESS, PAGE_SIZE);
+	gta02_timer = (void *) km_map(S3C24XX_TIMER_ADDRESS, PAGE_SIZE,
+	    PAGE_NOT_CACHEABLE);
+	irqc_regs = (void *) km_map(S3C24XX_IRQC_ADDRESS, PAGE_SIZE,
+	    PAGE_NOT_CACHEABLE);
 
 	/* Initialize interrupt controller. */
@@ -123,5 +126,5 @@
  * @param size		Place to store memory size.
  */
-static void gta02_get_memory_extents(uintptr_t *start, uintptr_t *size)
+static void gta02_get_memory_extents(uintptr_t *start, size_t *size)
 {
 	*start = GTA02_MEMORY_START + GTA02_MEMORY_SKIP;
Index: kernel/arch/arm32/src/mach/integratorcp/integratorcp.c
===================================================================
--- kernel/arch/arm32/src/mach/integratorcp/integratorcp.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/arm32/src/mach/integratorcp/integratorcp.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -45,4 +45,5 @@
 #include <mm/page.h>
 #include <mm/frame.h>
+#include <mm/km.h>
 #include <arch/mm/frame.h>
 #include <arch/mach/integratorcp/integratorcp.h>
@@ -128,10 +129,12 @@
 void icp_init(void)
 {
-	icp_hw_map.uart = hw_map(ICP_UART, PAGE_SIZE);
-	icp_hw_map.kbd_ctrl = hw_map(ICP_KBD, PAGE_SIZE);
+	icp_hw_map.uart = km_map(ICP_UART, PAGE_SIZE,
+	    PAGE_WRITE | PAGE_NOT_CACHEABLE);
+	icp_hw_map.kbd_ctrl = km_map(ICP_KBD, PAGE_SIZE, PAGE_NOT_CACHEABLE);
 	icp_hw_map.kbd_stat = icp_hw_map.kbd_ctrl + ICP_KBD_STAT;
 	icp_hw_map.kbd_data = icp_hw_map.kbd_ctrl + ICP_KBD_DATA;
 	icp_hw_map.kbd_intstat = icp_hw_map.kbd_ctrl + ICP_KBD_INTR_STAT;
-	icp_hw_map.rtc = hw_map(ICP_RTC, PAGE_SIZE);
+	icp_hw_map.rtc = km_map(ICP_RTC, PAGE_SIZE,
+	    PAGE_WRITE | PAGE_NOT_CACHEABLE);
 	icp_hw_map.rtc1_load = icp_hw_map.rtc + ICP_RTC1_LOAD_OFFSET;
 	icp_hw_map.rtc1_read = icp_hw_map.rtc + ICP_RTC1_READ_OFFSET;
@@ -141,10 +144,13 @@
 	icp_hw_map.rtc1_intrstat = icp_hw_map.rtc + ICP_RTC1_INTRSTAT_OFFSET;
 
-	icp_hw_map.irqc = hw_map(ICP_IRQC, PAGE_SIZE);
+	icp_hw_map.irqc = km_map(ICP_IRQC, PAGE_SIZE,
+	    PAGE_WRITE | PAGE_NOT_CACHEABLE);
 	icp_hw_map.irqc_mask = icp_hw_map.irqc + ICP_IRQC_MASK_OFFSET;
 	icp_hw_map.irqc_unmask = icp_hw_map.irqc + ICP_IRQC_UNMASK_OFFSET;
-	icp_hw_map.cmcr = hw_map(ICP_CMCR, PAGE_SIZE);
+	icp_hw_map.cmcr = km_map(ICP_CMCR, PAGE_SIZE,
+	    PAGE_WRITE | PAGE_NOT_CACHEABLE);
 	icp_hw_map.sdramcr = icp_hw_map.cmcr + ICP_SDRAMCR_OFFSET;
-	icp_hw_map.vga = hw_map(ICP_VGA, PAGE_SIZE);
+	icp_hw_map.vga = km_map(ICP_VGA, PAGE_SIZE,
+	    PAGE_WRITE | PAGE_NOT_CACHEABLE);
 
 	hw_map_init_called = true;
@@ -220,5 +226,5 @@
  * @param size		Place to store memory size.
  */
-void icp_get_memory_extents(uintptr_t *start, uintptr_t *size)
+void icp_get_memory_extents(uintptr_t *start, size_t *size)
 {
 	*start = 0;
Index: kernel/arch/arm32/src/mach/testarm/testarm.c
===================================================================
--- kernel/arch/arm32/src/mach/testarm/testarm.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/arm32/src/mach/testarm/testarm.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -37,4 +37,5 @@
 #include <arch/mach/testarm/testarm.h>
 #include <mm/page.h>
+#include <mm/km.h>
 #include <genarch/fb/fb.h>
 #include <abi/fb/visuals.h>
@@ -71,7 +72,10 @@
 void gxemul_init(void)
 {
-	gxemul_kbd = (void *) hw_map(GXEMUL_KBD_ADDRESS, PAGE_SIZE);
-	gxemul_rtc = (void *) hw_map(GXEMUL_RTC_ADDRESS, PAGE_SIZE);
-	gxemul_irqc = (void *) hw_map(GXEMUL_IRQC_ADDRESS, PAGE_SIZE);
+	gxemul_kbd = (void *) km_map(GXEMUL_KBD_ADDRESS, PAGE_SIZE,
+	    PAGE_WRITE | PAGE_NOT_CACHEABLE);
+	gxemul_rtc = (void *) km_map(GXEMUL_RTC_ADDRESS, PAGE_SIZE,
+	    PAGE_WRITE | PAGE_NOT_CACHEABLE);
+	gxemul_irqc = (void *) km_map(GXEMUL_IRQC_ADDRESS, PAGE_SIZE,
+	    PAGE_WRITE | PAGE_NOT_CACHEABLE);
 }
 
@@ -202,8 +206,8 @@
  * @param size		Place to store memory size.
  */
-void gxemul_get_memory_extents(uintptr_t *start, uintptr_t *size)
+void gxemul_get_memory_extents(uintptr_t *start, size_t *size)
 {
 	*start = 0;
-        *size = *((uintptr_t *) (GXEMUL_MP_ADDRESS + GXEMUL_MP_MEMSIZE_OFFSET));
+	*size = *((uintptr_t *) (GXEMUL_MP_ADDRESS + GXEMUL_MP_MEMSIZE_OFFSET));
 }
 
Index: kernel/arch/arm32/src/machine_func.c
===================================================================
--- kernel/arch/arm32/src/machine_func.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/arm32/src/machine_func.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -85,5 +85,5 @@
  * @param size		Place to store memory size.
  */
-void machine_get_memory_extents(uintptr_t *start, uintptr_t *size)
+void machine_get_memory_extents(uintptr_t *start, size_t *size)
 {
 	(machine_ops->machine_get_memory_extents)(start, size);
Index: kernel/arch/arm32/src/mm/frame.c
===================================================================
--- kernel/arch/arm32/src/mm/frame.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/arm32/src/mm/frame.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -39,24 +39,37 @@
 #include <config.h>
 #include <align.h>
+#include <macros.h>
 
-/** Address of the last frame in the memory. */
-uintptr_t last_frame = 0;
+static void frame_common_arch_init(bool low)
+{
+	uintptr_t base;
+	size_t size;
 
-/** Creates memory zones. */
-void frame_arch_init(void)
+	machine_get_memory_extents(&base, &size);
+	base = ALIGN_UP(base, FRAME_SIZE);
+	size = ALIGN_DOWN(size, FRAME_SIZE);
+	
+	if (!frame_adjust_zone_bounds(low, &base, &size))
+		return;
+
+	if (low) {
+		zone_create(ADDR2PFN(base), SIZE2FRAMES(size),
+		    BOOT_PAGE_TABLE_START_FRAME +
+		    BOOT_PAGE_TABLE_SIZE_IN_FRAMES,
+		    ZONE_AVAILABLE | ZONE_LOWMEM);
+	} else {
+		pfn_t conf = zone_external_conf_alloc(SIZE2FRAMES(size));
+		if (conf != 0)
+			zone_create(ADDR2PFN(base), SIZE2FRAMES(size), conf,
+			    ZONE_AVAILABLE | ZONE_HIGHMEM);
+	}
+	
+}
+
+/** Create low memory zones. */
+void frame_low_arch_init(void)
 {
-	uintptr_t mem_start, mem_size;
-	uintptr_t first_frame;
-	uintptr_t num_frames;
+	frame_common_arch_init(true);
 
-	machine_get_memory_extents(&mem_start, &mem_size);
-	first_frame = ALIGN_UP(mem_start, FRAME_SIZE);
-	last_frame = ALIGN_DOWN(mem_start + mem_size, FRAME_SIZE);
-	num_frames = (last_frame - first_frame) >> FRAME_WIDTH;
-	
-	/* All memory as one zone */
-	zone_create(first_frame >> FRAME_WIDTH, num_frames,
-	    BOOT_PAGE_TABLE_START_FRAME + BOOT_PAGE_TABLE_SIZE_IN_FRAMES, 0);
-	
 	/* blacklist boot page table */
 	frame_mark_unavailable(BOOT_PAGE_TABLE_START_FRAME,
@@ -64,4 +77,10 @@
 
 	machine_frame_init();
+}
+
+/** Create high memory zones. */
+void frame_high_arch_init(void)
+{
+	frame_common_arch_init(false);
 }
 
Index: kernel/arch/arm32/src/mm/km.c
===================================================================
--- kernel/arch/arm32/src/mm/km.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ kernel/arch/arm32/src/mm/km.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,58 @@
+/*
+ * Copyright (c) 2011 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup arm32mm
+ * @{
+ */
+
+#include <arch/mm/km.h>
+#include <mm/km.h>
+#include <config.h>
+#include <typedefs.h>
+#include <macros.h>
+
+void km_identity_arch_init(void)
+{
+	config.identity_base = KM_ARM32_IDENTITY_START;
+	config.identity_size = KM_ARM32_IDENTITY_SIZE;
+}
+
+void km_non_identity_arch_init(void)
+{
+	km_non_identity_span_add(KM_ARM32_NON_IDENTITY_START,
+	    KM_ARM32_NON_IDENTITY_SIZE);
+}
+
+bool km_is_non_identity_arch(uintptr_t addr)
+{
+	return iswithin(KM_ARM32_NON_IDENTITY_START,
+	    KM_ARM32_NON_IDENTITY_SIZE, addr, 1);
+}
+
+/** @}
+ */
Index: kernel/arch/arm32/src/mm/page.c
===================================================================
--- kernel/arch/arm32/src/mm/page.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/arm32/src/mm/page.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -37,4 +37,5 @@
 #include <genarch/mm/page_pt.h>
 #include <mm/page.h>
+#include <arch/mm/frame.h>
 #include <align.h>
 #include <config.h>
@@ -42,5 +43,5 @@
 #include <typedefs.h>
 #include <interrupt.h>
-#include <arch/mm/frame.h>
+#include <macros.h>
 
 /** Initializes page tables.
@@ -57,17 +58,18 @@
 	
 	uintptr_t cur;
+
 	/* Kernel identity mapping */
-	for (cur = PHYSMEM_START_ADDR; cur < last_frame; cur += FRAME_SIZE)
+	for (cur = PHYSMEM_START_ADDR;
+	    cur < min(config.identity_size, config.physmem_end);
+	    cur += FRAME_SIZE)
 		page_mapping_insert(AS_KERNEL, PA2KA(cur), cur, flags);
 	
+#ifdef HIGH_EXCEPTION_VECTORS
 	/* Create mapping for exception table at high offset */
-#ifdef HIGH_EXCEPTION_VECTORS
-	void *virtaddr = frame_alloc(ONE_FRAME, FRAME_KA);
-	page_mapping_insert(AS_KERNEL, EXC_BASE_ADDRESS, KA2PA(virtaddr), flags);
+	uintptr_t ev_frame = (uintptr_t) frame_alloc(ONE_FRAME, FRAME_NONE);
+	page_mapping_insert(AS_KERNEL, EXC_BASE_ADDRESS, ev_frame, flags);
 #else
 #error "Only high exception vector supported now"
 #endif
-	cur = ALIGN_DOWN(0x50008010, FRAME_SIZE);
-	page_mapping_insert(AS_KERNEL, PA2KA(cur), cur, flags);
 
 	page_table_unlock(AS_KERNEL, true);
@@ -78,37 +80,4 @@
 }
 
-/** Maps device into the kernel space.
- *
- * Maps physical address of device into kernel virtual address space (so it can
- * be accessed only by kernel through virtual address).
- *
- * @param physaddr Physical address where device is connected.
- * @param size Length of area where device is present.
- *
- * @return Virtual address where device will be accessible.
- */
-uintptr_t hw_map(uintptr_t physaddr, size_t size)
-{
-	if (last_frame + ALIGN_UP(size, PAGE_SIZE) >
-	    KA2PA(KERNEL_ADDRESS_SPACE_END_ARCH)) {
-		panic("Unable to map physical memory %p (%d bytes).",
-		    (void *) physaddr, size);
-	}
-	
-	uintptr_t virtaddr = PA2KA(last_frame);
-	pfn_t i;
-
-	page_table_lock(AS_KERNEL, true);
-	for (i = 0; i < ADDR2PFN(ALIGN_UP(size, PAGE_SIZE)); i++) {
-		page_mapping_insert(AS_KERNEL, virtaddr + PFN2ADDR(i),
-		    physaddr + PFN2ADDR(i),
-		    PAGE_NOT_CACHEABLE | PAGE_READ | PAGE_WRITE | PAGE_KERNEL);
-	}
-	page_table_unlock(AS_KERNEL, true);
-	
-	last_frame = ALIGN_UP(last_frame + size, FRAME_SIZE);
-	return virtaddr;
-}
-
 /** @}
  */
Index: kernel/arch/arm32/src/ras.c
===================================================================
--- kernel/arch/arm32/src/ras.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/arm32/src/ras.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -38,4 +38,5 @@
 #include <mm/frame.h>
 #include <mm/page.h>
+#include <mm/km.h>
 #include <mm/tlb.h>
 #include <mm/asid.h>
@@ -50,18 +51,16 @@
 void ras_init(void)
 {
-	ras_page = frame_alloc(ONE_FRAME, FRAME_KA);
-	memsetb(ras_page, FRAME_SIZE, 0); 
+	uintptr_t frame;
+
+	frame = (uintptr_t) frame_alloc(ONE_FRAME,
+	    FRAME_ATOMIC | FRAME_HIGHMEM);
+	if (!frame)
+		frame = (uintptr_t) frame_alloc(ONE_FRAME, FRAME_LOWMEM);
+	ras_page = (uintptr_t *) km_map(frame,
+	    PAGE_SIZE, PAGE_READ | PAGE_WRITE | PAGE_USER | PAGE_CACHEABLE);
+
+	memsetb(ras_page, PAGE_SIZE, 0); 
 	ras_page[RAS_START] = 0;
 	ras_page[RAS_END] = 0xffffffff;
-	/*
-	 * Userspace needs to be able to write to this page. The page is 
-	 * cached in TLB as PAGE_KERNEL. Purge it from TLB and map it
-	 * read/write PAGE_USER.
-	 */
-	tlb_invalidate_pages(ASID_KERNEL, (uintptr_t)ras_page, 1);
-	page_table_lock(AS, true);
-	page_mapping_insert(AS, (uintptr_t)ras_page, (uintptr_t)KA2PA(ras_page),
-	    PAGE_READ | PAGE_WRITE | PAGE_USER);
-	page_table_unlock(AS, true);
 }
 
Index: kernel/arch/ia32/Makefile.inc
===================================================================
--- kernel/arch/ia32/Makefile.inc	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/ia32/Makefile.inc	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -99,4 +99,5 @@
 	arch/$(KARCH)/src/userspace.c \
 	arch/$(KARCH)/src/cpu/cpu.c \
+	arch/$(KARCH)/src/mm/km.c \
 	arch/$(KARCH)/src/mm/as.c \
 	arch/$(KARCH)/src/mm/frame.c \
Index: kernel/arch/ia32/include/interrupt.h
===================================================================
--- kernel/arch/ia32/include/interrupt.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/ia32/include/interrupt.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -55,5 +55,4 @@
 #define IRQ_PIC_SPUR  7
 #define IRQ_MOUSE     12
-#define IRQ_NE2000    5
 
 /* This one must have four least significant bits set to ones */
Index: kernel/arch/ia32/include/mm/frame.h
===================================================================
--- kernel/arch/ia32/include/mm/frame.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/ia32/include/mm/frame.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -43,7 +43,6 @@
 #include <typedefs.h>
 
-extern uintptr_t last_frame;
-
-extern void frame_arch_init(void);
+extern void frame_low_arch_init(void);
+extern void frame_high_arch_init(void);
 extern void physmem_print(void);
 
Index: kernel/arch/ia32/include/mm/km.h
===================================================================
--- kernel/arch/ia32/include/mm/km.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ kernel/arch/ia32/include/mm/km.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,53 @@
+/*
+ * Copyright (c) 2011 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup ia32mm
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_ia32_KM_H_
+#define KERN_ia32_KM_H_
+
+#include <typedefs.h>
+
+#define KM_IA32_IDENTITY_START		UINT32_C(0x80000000)
+#define KM_IA32_IDENTITY_SIZE		UINT32_C(0x40000000)
+
+#define KM_IA32_NON_IDENTITY_START	UINT32_C(0xc0000000)
+#define KM_IA32_NON_IDENTITY_SIZE	UINT32_C(0x40000000)
+
+extern void km_identity_arch_init(void);
+extern void km_non_identity_arch_init(void);
+extern bool km_is_non_identity_arch(uintptr_t);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/ia32/src/boot/multiboot2.S
===================================================================
--- kernel/arch/ia32/src/boot/multiboot2.S	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/ia32/src/boot/multiboot2.S	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -53,5 +53,7 @@
 		.long MULTIBOOT2_TAG_MODULE
 		.long MULTIBOOT2_TAG_MEMMAP
+#ifdef CONFIG_FB
 		.long MULTIBOOT2_TAG_FBINFO
+#endif
 	tag_info_req_end:
 	
@@ -83,4 +85,5 @@
 	tag_flags_end:
 	
+#ifdef CONFIG_FB
 	/* Framebuffer tag */
 	tag_framebuffer_start:
@@ -92,4 +95,5 @@
 		.long CONFIG_BFB_BPP
 	tag_framebuffer_end:
+#endif
 	
 	/* Module alignment tag */
Index: kernel/arch/ia32/src/boot/vesa_real.inc
===================================================================
--- kernel/arch/ia32/src/boot/vesa_real.inc	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/ia32/src/boot/vesa_real.inc	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -374,5 +374,5 @@
 		xor %ebx, %ebx
 		xor %edx, %edx
-		mov $0xffffffff, %edi
+		xor %edi, %edi
 		
 		jz vesa_leave_real  /* force relative jump */
Index: kernel/arch/ia32/src/ia32.c
===================================================================
--- kernel/arch/ia32/src/ia32.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/ia32/src/ia32.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -36,38 +36,24 @@
 
 #include <arch.h>
-
 #include <typedefs.h>
-
-#include <arch/pm.h>
-
+#include <errno.h>
+#include <memstr.h>
+#include <interrupt.h>
+#include <console/console.h>
+#include <syscall/syscall.h>
+#include <sysinfo/sysinfo.h>
+#include <arch/bios/bios.h>
+#include <arch/boot/boot.h>
+#include <arch/debugger.h>
+#include <arch/drivers/i8254.h>
+#include <arch/drivers/i8259.h>
+#include <genarch/acpi/acpi.h>
+#include <genarch/drivers/ega/ega.h>
+#include <genarch/drivers/i8042/i8042.h>
+#include <genarch/drivers/legacy/ia32/io.h>
+#include <genarch/fb/bfb.h>
+#include <genarch/kbrd/kbrd.h>
 #include <genarch/multiboot/multiboot.h>
 #include <genarch/multiboot/multiboot2.h>
-#include <genarch/drivers/legacy/ia32/io.h>
-#include <genarch/drivers/ega/ega.h>
-#include <genarch/fb/bfb.h>
-#include <genarch/drivers/i8042/i8042.h>
-#include <genarch/kbrd/kbrd.h>
-#include <arch/drivers/i8254.h>
-#include <arch/drivers/i8259.h>
-
-#include <arch/context.h>
-
-#include <config.h>
-
-#include <arch/interrupt.h>
-#include <arch/asm.h>
-#include <genarch/acpi/acpi.h>
-
-#include <arch/bios/bios.h>
-
-#include <interrupt.h>
-#include <ddi/irq.h>
-#include <arch/debugger.h>
-#include <proc/thread.h>
-#include <syscall/syscall.h>
-#include <console/console.h>
-#include <sysinfo/sysinfo.h>
-#include <arch/boot/boot.h>
-#include <memstr.h>
 
 #ifdef CONFIG_SMP
@@ -182,22 +168,8 @@
 		}
 	}
-	
-	/*
-	 * This is the necessary evil until the userspace driver is entirely
-	 * self-sufficient.
-	 */
-	sysinfo_set_item_val("i8042", NULL, true);
-	sysinfo_set_item_val("i8042.inr_a", NULL, IRQ_KBD);
-	sysinfo_set_item_val("i8042.inr_b", NULL, IRQ_MOUSE);
-	sysinfo_set_item_val("i8042.address.physical", NULL,
-	    (uintptr_t) I8042_BASE);
-	sysinfo_set_item_val("i8042.address.kernel", NULL,
-	    (uintptr_t) I8042_BASE);
 #endif
 	
 	if (irqs_info != NULL)
 		sysinfo_set_item_val(irqs_info, NULL, true);
-	
-	sysinfo_set_item_val("netif.ne2000.inr", NULL, IRQ_NE2000);
 }
 
@@ -219,10 +191,10 @@
  * selector, and the descriptor->base is the correct address.
  */
-sysarg_t sys_tls_set(sysarg_t addr)
+sysarg_t sys_tls_set(uintptr_t addr)
 {
 	THREAD->arch.tls = addr;
 	set_tls_desc(addr);
 	
-	return 0;
+	return EOK;
 }
 
Index: kernel/arch/ia32/src/mm/frame.c
===================================================================
--- kernel/arch/ia32/src/mm/frame.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/ia32/src/mm/frame.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -46,67 +46,33 @@
 #include <print.h>
 
-#define PHYSMEM_LIMIT32  UINT64_C(0x07c000000)
-#define PHYSMEM_LIMIT64  UINT64_C(0x200000000)
+#define PHYSMEM_LIMIT32  UINT64_C(0x100000000)
 
 size_t hardcoded_unmapped_ktext_size = 0;
 size_t hardcoded_unmapped_kdata_size = 0;
 
-uintptr_t last_frame = 0;
-
-static void init_e820_memory(pfn_t minconf)
+static void init_e820_memory(pfn_t minconf, bool low)
 {
 	unsigned int i;
 	
 	for (i = 0; i < e820counter; i++) {
-		uint64_t base = e820table[i].base_address;
-		uint64_t size = e820table[i].size;
+		uint64_t base64 = e820table[i].base_address;
+		uint64_t size64 = e820table[i].size;
 		
-#ifdef __32_BITS__
+#ifdef KARCH_ia32
 		/*
-		 * XXX FIXME:
-		 *
-		 * Ignore zones which start above PHYSMEM_LIMIT32
-		 * or clip zones which go beyond PHYSMEM_LIMIT32.
-		 *
-		 * The PHYSMEM_LIMIT32 (2 GB - 64 MB) is a rather
-		 * arbitrary constant which allows to have at
-		 * least 64 MB in the kernel address space to
-		 * map hardware resources.
-		 *
-		 * The kernel uses fixed 1:1 identity mapping
-		 * of the physical memory with 2:2 GB split.
-		 * This is a severe limitation of the current
-		 * kernel memory management.
-		 *
+		 * Restrict the e820 table entries to 32-bits.
 		 */
-		
-		if (base > PHYSMEM_LIMIT32)
+		if (base64 >= PHYSMEM_LIMIT32)
 			continue;
 		
-		if (base + size > PHYSMEM_LIMIT32)
-			size = PHYSMEM_LIMIT32 - base;
+		if (base64 + size64 > PHYSMEM_LIMIT32)
+			size64 = PHYSMEM_LIMIT32 - base64;
 #endif
 		
-#ifdef __64_BITS__
-		/*
-		 * XXX FIXME:
-		 *
-		 * Ignore zones which start above PHYSMEM_LIMIT64
-		 * or clip zones which go beyond PHYSMEM_LIMIT64.
-		 *
-		 * The PHYSMEM_LIMIT64 (8 GB) is the size of the
-		 * fixed 1:1 identically mapped physical memory
-		 * accessible during the bootstrap process.
-		 * This is a severe limitation of the current
-		 * kernel memory management.
-		 *
-		 */
+		uintptr_t base = (uintptr_t) base64;
+		size_t size = (size_t) size64;
 		
-		if (base > PHYSMEM_LIMIT64)
+		if (!frame_adjust_zone_bounds(low, &base, &size))
 			continue;
-		
-		if (base + size > PHYSMEM_LIMIT64)
-			size = PHYSMEM_LIMIT64 - base;
-#endif
 		
 		if (e820table[i].type == MEMMAP_MEMORY_AVAILABLE) {
@@ -116,18 +82,21 @@
 			    FRAME_SIZE);
 			
+			size_t count = SIZE2FRAMES(new_size);
 			pfn_t pfn = ADDR2PFN(new_base);
-			size_t count = SIZE2FRAMES(new_size);
+			pfn_t conf;
 			
-			pfn_t conf;
-			if ((minconf < pfn) || (minconf >= pfn + count))
-				conf = pfn;
-			else
-				conf = minconf;
-			
-			zone_create(pfn, count, conf, ZONE_AVAILABLE);
-			
-			// XXX this has to be removed
-			if (last_frame < ALIGN_UP(new_base + new_size, FRAME_SIZE))
-				last_frame = ALIGN_UP(new_base + new_size, FRAME_SIZE);
+			if (low) {
+				if ((minconf < pfn) || (minconf >= pfn + count))
+					conf = pfn;
+				else
+					conf = minconf;
+				zone_create(pfn, count, conf,
+				    ZONE_AVAILABLE | ZONE_LOWMEM);
+			} else {
+				conf = zone_external_conf_alloc(count);
+				if (conf != 0)
+					zone_create(pfn, count, conf,
+					    ZONE_AVAILABLE | ZONE_HIGHMEM);
+			}
 		} else if ((e820table[i].type == MEMMAP_MEMORY_ACPI) ||
 		    (e820table[i].type == MEMMAP_MEMORY_NVS)) {
@@ -179,5 +148,5 @@
 
 
-void frame_arch_init(void)
+void frame_low_arch_init(void)
 {
 	pfn_t minconf;
@@ -192,5 +161,5 @@
 #endif
 		
-		init_e820_memory(minconf);
+		init_e820_memory(minconf, true);
 		
 		/* Reserve frame 0 (BIOS data) */
@@ -206,4 +175,10 @@
 }
 
+void frame_high_arch_init(void)
+{
+	if (config.cpu_active == 1)
+		init_e820_memory(0, false);
+}
+
 /** @}
  */
Index: kernel/arch/ia32/src/mm/km.c
===================================================================
--- kernel/arch/ia32/src/mm/km.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ kernel/arch/ia32/src/mm/km.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,58 @@
+/*
+ * Copyright (c) 2011 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup ia32mm
+ * @{
+ */
+
+#include <arch/mm/km.h>
+#include <mm/km.h>
+#include <config.h>
+#include <typedefs.h>
+#include <macros.h>
+
+void km_identity_arch_init(void)
+{
+	config.identity_base = KM_IA32_IDENTITY_START;
+	config.identity_size = KM_IA32_IDENTITY_SIZE;
+}
+
+void km_non_identity_arch_init(void)
+{
+	km_non_identity_span_add(KM_IA32_NON_IDENTITY_START,
+	    KM_IA32_NON_IDENTITY_SIZE);
+}
+
+bool km_is_non_identity_arch(uintptr_t addr)
+{
+	return iswithin(KM_IA32_NON_IDENTITY_START, KM_IA32_NON_IDENTITY_SIZE,
+	    addr, 1);
+}
+
+/** @}
+ */
